import permision from "@/js_sdk/wa-permission/permission.js";
import md5 from "@/js_sdk/md5.js";
// 正义
// const baseRequest = "http://192.168.0.145:8088/api/";
// const baseRequest2="http://192.168.0.56:4565/";
const baseRequest = "http://apptest.anmodaojiawang.com/api/";
let newBaseRequest = "https://www.anmodaojiaapp.com/"
const baseRequest2 = "http://apptest.anmodaojiawang.com/";

const imagrurl = "https://anmodaojia-1251514996.cos.ap-chongqing.myqcloud.com/";
// 表单签名KEY
const APPSECRET = 'B3qqhtbFTO4b05MsV3gmew3RVoOEa9wc';

// 参数加密KEY
const APPKEY = '4NrQjCDolPhKh1sbJggz8g0LeTd01n9eJq2fZ4ikLe4QePnUC2d0NddZpxwToqX8';
const request = ($path, $method, $param) => {
	return new Promise((reslove, reject) => {
		const timeout = 60000
		const dataType = 'json';
		var dw = uni.getStorageSync('address')
		// console.log(dw)
		// console.log(uni.getStorageSync('usrToken'));
		uni.request({
			url: baseRequest + $path,
			data: $param,
			header: {
				// 'content-Type': 'application/json',
				'citycode': dw.citycode ? dw.citycode : '',
				'city': dw.city ? dw.city : '',
				'token': uni.getStorageSync('usrToken'),
				'lng': dw.longitude ? dw.longitude : '',
				'lat': dw.latitude ? dw.latitude : '',
				'content-type': 'application/x-www-form-urlencoded'
			},
			method: $method,
			timeout: timeout,
			dataType: dataType,
			success: res => {
				if (res.data.code == 1) {
					reslove(res.data)
				} else {
					// console.log(res.data)
					reject(res.data)
					if (res.data.code == 401) {
						//uni.removeStorageSync('usrToken');
						// console.log('清除token成功')
					}
				}
			},
			fail: err => {
				if (err.errMsg) {
					err.msg = err.errMsg
				}

				reject(err)
			}
		})
	})
}

let isDev = uni.getStorageSync('app_isDev')
//修改环境
const modifEnvir = (type) => {
	// if (type === 1) { //开发
	// 	newBaseRequest = "https://api.anmodaojiaapp.com/"
	// } else if (type === 2) { //正式环境
	// 	newBaseRequest = "https://api.anmodaojia.com/"
	// }

	isDev = uni.getStorageSync('app_isDev')
}

function getVersion() {
	let version = '1.0.0'
	return new Promise((resolve, reject) => {
		plus.runtime.getProperty(plus.runtime.appid, (widgetInfo) => {

			version = plus.runtime.version >= widgetInfo.version ? plus.runtime.version : widgetInfo
				.version

			resolve(version)
		})
	})
}

// 监听网络
function networkType() {
	return new Promise(async (reslove, reject) => {
		uni.getNetworkType({ //首次判断是否有网
			success: res => {
				if (res.networkType !== 'none') {
					reslove(true)
				} else {
					uni.onNetworkStatusChange(res => { //没开启网络的情况下开启监听
						if (res.isConnected !== false) {
							reslove(true)
						}
					})
				}
			}
		})
	})
}

const newRequest = ($path, $method, $param, isHandleError = false) => {
	return new Promise(async (reslove, reject) => {
		await networkType()
		const timeout = 6000 //60000
		const dataType = 'json';
		var dw = uni.getStorageSync('address')
		let app_type = uni.getStorageSync('app_type').type

		//获取的设备信息
		let deviceMsg = {}
		let channelCode = uni.getStorageSync('xinstallDevice')
		//if (!app_type) {
		deviceMsg = uni.getSystemInfoSync()||{}
		let platform = deviceMsg.platform
		let platType = deviceMsg.uniPlatform
		let version = '1.0.0'
		let imei = ''
		// #ifdef APP-PLUS
		version = await getVersion()
		imei = plus.device.imei
		// #endif
		

		if (platform == 'android' && platType == 'app') {
			app_type = 1
		} else if (platform == 'ios' && platType == 'app') {
			app_type = 2
		} else if (platType == 'web' || platType == 'h5') {
			app_type = 3
		}
		uni.setStorageSync('app_type', {
			type: app_type
		})

		//	}
		// console.log('请求时的地理位置坐标：', dw, version);
		// console.log('请求时的应用类型：', uni.getSystemInfoSync().platform, app_type);
		// console.log(dw)
		// console.log(uni.getStorageSync('usrToken'));
		uni.request({
			url: getApp().$httpUrl + $path,
			data: $param,
			header: {
				"version": version,
				"type": app_type,
				"city": dw.city ? encodeURIComponent(dw.city) : '',
				"citycode": dw.citycode ? dw.citycode : '',
				'token': uni.getStorageSync('usrToken'),
				'lng': dw.longitude ? dw.longitude : '',
				'lat': dw.latitude ? dw.latitude : '',
				'address':dw.poiName ? encodeURIComponent(dw.poiName) : '',
				'channelCode': channelCode ? channelCode : '',
				'appWgtVersion': deviceMsg.appWgtVersion ? deviceMsg.appWgtVersion : '',
				'appVersion': deviceMsg.appVersion ? deviceMsg.appVersion : '',
				'appVersionCode': deviceMsg.deviceMsg ? deviceMsg.deviceMsg : '',
				'deviceType': deviceMsg.deviceType ? deviceMsg.deviceType : '',
				'deviceBrand': deviceMsg.deviceBrand ? deviceMsg.deviceBrand : '',
				'deviceModel': deviceMsg.deviceModel ? deviceMsg.deviceModel : '',
				'osName': deviceMsg.osName ? deviceMsg.osName : '',
				'osVersion': deviceMsg.osVersion ? deviceMsg.osVersion : '',
				'browserName': deviceMsg.browserName ? deviceMsg.browserName : '',
				'browserVersion': deviceMsg.browserVersion ? deviceMsg.browserVersion : '',
				'oaid': deviceMsg.oaid || '',
				'idfa': deviceMsg.idfa || '',
				'deviceId':deviceMsg.deviceId || '',
				'imei':imei || ''
			},
			method: $method,
			timeout: timeout,
			dataType: dataType,
			success: res => {

				console.log('tttttttt')
				console.log(res.data)
				if (res.data.code == 200 || res.data.code == 1 || res.data.code == 10001) {
					reslove(res.data)
				} else {
					// console.log(res.data)

					if (res.data.code == 888) {

						if (isHandleError) {
							reject(res.data)
							return
						}
						uni.setStorageSync('usrToken', '')
						uni.setStorageSync('usrId', '')
						uni.setStorageSync('xr_day', '')
						//uni.setStorageSync('ifToLogin', 1)

						// #ifdef APP-PLUS
						uni.navigateTo({
							url: "/pages/index/login"
						})
						// #endif

						// #ifdef H5
						uni.navigateTo({
							url: "/pages/index/login"
						})
						//window.location.href = 'https://open.weixin.qq.com/connect/oauth2/authorize?appid=wx33eb29ddaaa66979&redirect_uri=https%3A%2F%2Fwap.anmodaojiaapp.com%2F&response_type=code&scope=snsapi_userinfo&state=STATE#wechat_redirect'
						// #endif
						// console.log('清除token成功')
					} else {
						if (!isHandleError) {
							uni.showToast({
								icon: 'none',
								title: res.data.msg
							})

							return
						}
					}

					reject(res.data)
				}
			},
			fail: err => {
				if (err.errMsg) {
					err.msg = err.errMsg
				}
				reject(err)
			}
		})
	})
}

function getOnlyIds(palt){
	return new Promise(resolve=>{
		
		if (palt == 'ios') {
			 plus.device.getInfo({ //需要勾选IDFA
				success:function(e) {
					console.log('获取设备id=======',e);
					resolve(e)
				},
			})
		}else{
			plus.device.getOAID({
					success:function(e){
						console.log('获取安卓设备id=======',e);
						resolve(e)
					},
				});
		}
	})
}

const request2 = ($path, $method, $param) => {
	return new Promise((reslove, reject) => {
		const timeout = 60000
		const dataType = 'json';
		// console.log(sign(APPSECRET,$param));
		uni.request({
			url: baseRequest2 + $path,
			data: $param,
			header: {
				// 'content-Type': 'application/json',
				// 'token': '7061711b-53dc-487d-a0b8-0fbc41e9befa_technician', //测试token 技师端
				'token': uni.getStorageSync('usrToken'), //测试token 商家端
				'content-type': 'application/x-www-form-urlencoded'
			},
			method: $method,
			timeout: timeout,
			dataType: dataType,
			success: res => {
				if (res.data.code == 1) {
					reslove(res.data)
				} else {
					reject(res.data)
				}
			},
			fail: err => {
				reject(err)
			}
		})
	})
}

/*
	参数加签Start
*/
function sort(data) {
	var keys = Object.keys(data).sort();
	var result = {};
	for (var i = 0; i < keys.length; i++) {
		var key = keys[i];
		result[key] = data[key];
	}
	return result;
}

function mtRand(min, max) {
	var result = Math.random() * (max - min + 1) + min;
	return parseInt(result);
}

/*
	依赖MD5.js
*/
function sign(appkey, json) {
	json.timestamp = Date.parse(new Date()) / 1000;
	json.nonce_str = mtRand(100000, 999999);
	json = sort(json);
	var str = '';
	for (var k in json) {
		if (str != '')
			str += '&'
		str += k + '=' + json[k]
	}
	str += '&key=' + appkey;
	json.key = appkey;
	json.sign = md5(str).toUpperCase();
	delete json.key;
	return json;
}
/*
	参数加签END
*/

/**
* @description:字符串加密
	* @param:{
	  String str 必传=>需要加密的字符串
		* @return 返回加密后的字符串
	}
*/
const post_en = ($_str) => {
	var staticchars = APPKEY;
	var encodechars = "";
	for (var i = 0; i < _str.length; i++) {
		var num0 = staticchars.indexOf(_str[i]);
		if (num0 == -1) {
			var code = _str[i];
		} else {
			var code = staticchars[(num0 + 3) % 62];
		}
		var num1 = parseInt(Math.random() * 62, 10);
		var num2 = parseInt(Math.random() * 62, 10);
		encodechars += staticchars[num1] + code + staticchars[num2];
	}
	return encodechars;
}

const uploadFile = ($url, $arr, $cb) => {
	let file = new Promise(function(resolve, reject) {
		uni.compressImage({
			src: $arr,
			quality: 40,
			success: res => {
				uni.uploadFile({
					url: baseRequest + $url,
					filePath: res.tempFilePath,
					name: 'file',
					header: {
						'Content-Type': 'multipart/form-data',
					},
					success: (uploadFileRes) => {
						if (JSON.parse(uploadFileRes.data).code == 1) {
							resolve(JSON.parse(uploadFileRes.data).data.url);
						}
					}
				});
			}
		})
	});
	file.then(function(data) {
		$cb(data);
	});
}

//路由跳转 //保留当前页面
const navigateTo = ($path, $data, $events) => {
	if (!$data) $data = {}
	if (!$events) $events = {}
	uni.navigateTo({
		url: $path,
		events: $events,
		success: (res) => {
			res.eventChannel.emit('acceptDataFromOpenerPage', $data)
		},
		fail: (err) => {
			console.log(err)
		}
	})
}
// 关闭当前页面跳转
const redirectTo = ($path, $data, $events) => {
	if (!$data) $data = {}
	if (!$events) $events = {}
	uni.redirectTo({
		url: $path,
		events: $events,
		success: (res) => {
			res.eventChannel.emit('acceptDataFromOpenerPage', $data)
		},
		fail: (err) => {
			console.log(err)
		}
	})
}
// bar跳转
const goBar = ($path) => {
	uni.switchTab({
		url: $path
	});
}

const showToast = ($title, $icon) => {
	uni.showToast({
		title: $title,
		icon: $icon ? $icon : 'none'
	})
}
//显示模态弹窗
const showModal = ($title, $content, $callback) => {
	uni.showModal({
		title: $title,
		content: $content,
		success: res => {
			if ($callback) {
				$callback(res)
			}
		}
	})
}
//从底部向上弹出操作菜单
const showActionSheet = ($itemList, $cb) => {
	uni.showActionSheet({
		itemList: $itemList,
		success: res => {
			if ($cb) {
				$cb(res.tapIndex)
			}
		},
		fail: res => {}
	});
}

//权限请求
const gloabSetting = ($authorize, $permissionId, $content, $errText) => {
	// #ifdef MP-WEIXIN || MP-ALIPAY || MP-QQ || MP-BAIDU || MP-TOUTIAO
	return new Promise((reslove, reject) => {
		uni.getSetting({
			success: res => {
				if (res.authSetting[$authorize]) {
					reslove()
				} else {
					uni.authorize({
						scope: $authorize,
						success: () => {
							reslove()
						},
						fail: () => {
							reject()
							showModal('remind', $content, (s) => {
								if (s.confirm) {
									navigateTo(
										'/pages/authorize/authorize?scope=' +
										$authorize)
								} else {
									showToast($errText, 'none')
								}
							})
						}
					})
				}
			}
		})
	})
	//#endif

	//#ifdef APP-PLUS
	return new Promise((reslove, reject) => {
		if (plus.os.name == "iOS") {
			reslove()
		} else {
			permision.requestAndroidPermission($permissionId).then((result) => {
				if (result == 1) {
					reslove()
				} else if (result == 0) {
					reject()
				} else {
					showModal('remind', $content, (s) => {
						if (s.confirm) {
							permision.gotoAppPermissionSetting()
						} else {
							showToast($errText, 'none')
						}
					})
					reject()
				}
			})
		}
	})
	//#endif

}

//从本地相册选择图片或使用相机拍照(含兼容多端权限请求)
const chooseImage = ($count, $cb) => {
	showActionSheet(['打开相机', '打开相册'], ($method) => {
		let permissionId = ""
		//#ifdef APP-PLUS
		if (plus.os.name == "iOS") {
			permissionId = $method == 1 ? 'photoLibrary' : 'camera'
		} else {
			permissionId = $method == 1 ? 'android.permission.READ_EXTERNAL_STORAGE' :
				'android.permission.CAMERA'
		}
		//#endif
		gloabSetting('scope.camera', permissionId, "Please authorize camera album permissions",
			'Cannot use camera album function').then(() => {
			const sourceType = $method == 1 ? ['album'] : ['camera']
			uni.chooseImage({
				count: $count, //默认9
				sizeType: ['original'], //可以指定是原图还是压缩图，默认二者都有
				sourceType: sourceType, //从相册选择
				success: (res) => {
					if ($cb) {
						$cb(res.tempFilePaths)
					}
				},
				fail: (err) => {
					// #ifdef APP-PLUS  
					if (plus.os.name == 'iOS') {
						if ($method == 1) {
							const PHPhotoLibrary = plus.ios.importClass(
								'PHPhotoLibrary')
							const PHAuthorizationStatus = PHPhotoLibrary
								.authorizationStatus()
							if (PHAuthorizationStatus != 3) {
								showModal('remind',
									'To access your album, please enable it in the settings',
									(s) => {
										if (s.confirm) {
											permision.gotoAppPermissionSetting()
										}
									}, 'set up')
							}
							plus.ios.deleteObject(PHPhotoLibrary);
						} else {
							const AVCaptureDevice = plus.ios.import("AVCaptureDevice")
							const authStatus = AVCaptureDevice
								.authorizationStatusForMediaType('vide')
							if (authStatus != 3) {
								showModal('remind',
									'Need to access your camera, please turn it on in the settings',
									(s) => {
										if (s.confirm) {
											permision.gotoAppPermissionSetting()
										}
									}, 'set up')
							}
							plus.ios.deleteObject(AVCaptureDevice);
						}
					}
					// #endif
				}
			});
		})
	})
}
const chooseImageNewMethods = ($count, $cb) => {

	showActionSheet(['打开相机', '打开相册'], ($method) => {
		let permissionId = ""
		//#ifdef APP-PLUS
		const sourceType = $method == 1 ? ['album'] : ['camera']
		if (plus.os.name == "iOS") {
			permissionId = $method == 1 ? 'photoLibrary' : 'camera'

			uni.chooseImage({
				count: $count, //默认9
				sizeType: ['original'], //可以指定是原图还是压缩图，默认二者都有
				sourceType: sourceType, //从相册选择
				success: (res) => {
					console.log(res)

					if ($cb) {
						$cb(res.tempFilePaths)
					}
				},
				fail: (err) => {
					console.log('错误')
					console.log(err)
					// #ifdef APP-PLUS
					if (plus.os.name == 'iOS') {
						if ($method == 1) {
							//相册自带提示
							return
							const PHPhotoLibrary = plus.ios.importClass(
								'PHPhotoLibrary')
							const PHAuthorizationStatus = PHPhotoLibrary
								.authorizationStatus()
							if (PHAuthorizationStatus != 3) {
								showModal('提示',
									'相册读取功能被永久拒绝权限,是否前往开启,否则将影响使用',
									(s) => {
										if (s.confirm) {
											permision.gotoAppPermissionSetting()
										}
									}, 'set up')
							}
							plus.ios.deleteObject(PHPhotoLibrary);
						} else {

							const AVCaptureDevice = plus.ios.import("AVCaptureDevice")
							const authStatus = AVCaptureDevice
								.authorizationStatusForMediaType('vide')
							if (authStatus != 3) {
								showModal('提示',
									'拍照功能被永久拒绝权限,是否前往开启,否则将影响使用',
									(s) => {
										if (s.confirm) {
											permision.gotoAppPermissionSetting()
										}
									}, 'set up')
							}
							plus.ios.deleteObject(AVCaptureDevice)
						}
					}

					// #endif
				}
			});




		} else {
			permissionId = $method == 1 ? 'android.permission.READ_EXTERNAL_STORAGE' :
				'android.permission.CAMERA'
			//安卓
			permision.requestAndroidPermission(permissionId).then(res => {
				console.log('返回权限状态码')
				console.log(res)
				if (res != 1) {
					showModal('提示',
						'拍照功能被永久拒绝权限,是否前往开启,否则将影响使用',
						(s) => {
							if (s.confirm) {
								permision.gotoAppPermissionSetting()
							}
						}, 'set up')
				} else {
					console.log('进入有权限')
					uni.chooseImage({
						count: $count, //默认9
						sizeType: ['original', 'compressed'], //可以指定是原图还是压缩图，默认二者都有
						sourceType: sourceType, //从相册选择
						success: function(res) {
							console.log('ttttttttttt')
							console.log(JSON.stringify(res.tempFilePaths));

							if ($cb) {
								$cb(res.tempFilePaths)
							}
						},
						fail: function(err) {
							console.log('fail')
							console.log(err)
						}
					})
				}
			})

		}


		//#endif



	})
}

//获取状态栏高度
const getBarHeight = () => {
	// #ifndef MP-TOUTIAO
	return uni.getSystemInfoSync()['statusBarHeight']
	// #endif
	return 0;
}

//剪切板
const setClipboardData = ($data, $cb) => {
	uni.setClipboardData({
		data: $data,
		success: () => {
			if ($cb) $cb()
		}
	});
}
// 返回
const close = () => {
	uni.navigateBack();
}

const uploadList = ($url, $arr) => {
	let num = 0;
	const uploadPics = ($arr, $cb, reject) => {
		// console.log($arr);
		uni.compressImage({
			src: $arr[num],
			quality: 40,
			success: res => {
				uni.uploadFile({
					url: baseRequest + $url,
					filePath: res.tempFilePath,
					name: 'file',
					header: {
						'Content-Type': 'multipart/form-data',
					},
					success: (uploadFileRes) => {
						// console.log(uploadFileRes);
						if (JSON.parse(uploadFileRes.data).code == 1) {
							$arr[num] = JSON.parse(uploadFileRes.data).data.url
						}
						if (($arr.length - 1) == num) {
							$cb($arr)
						} else {
							num++
							uploadPics($arr, $cb, reject);
						}
					},
					fail: err => {
						console.log(err);
						reject('Upload failed, upload again');
					}
				});
			}
		})
	}
	return new Promise((reslove, reject) => {
		uploadPics($arr, (arr) => {
			reslove(arr)
		}, reject)
	})


}

// 判断手机移动数据是否打开
const mobileData = () => {
	plus.android.importClass('android.net.ConnectivityManager')
	let context = plus.android.importClass('android.content.Context');
	let ConnectivityManager = plus.android.runtimeMainActivity().getSystemService(context.CONNECTIVITY_SERVICE);
	return ConnectivityManager.getMobileDataEnabled();
}

export default {
	request,
	newRequest,
	request2,
	navigateTo,
	gloabSetting,
	uploadFile,
	uploadList,
	showModal,
	showActionSheet,
	chooseImage,
	showToast,
	getBarHeight,
	close,
	post_en,
	goBar,
	setClipboardData,
	chooseImageNewMethods,
	mobileData,
	modifEnvir,
	redirectTo,networkType
}