import check_permission from "@/static/script/permition.js"
//打开定位开关
function openLoc(){
	uni.showModal({
		title: '提示',
		content: '请打开定位服务',
		success: ({
			confirm,
			cancel
		}) => {
			if (confirm) {
				// android平台
				if (uni.getSystemInfoSync().platform == 'android') {
					var Intent = plus.android.importClass('android.content.Intent');
					var Settings = plus.android.importClass('android.provider.Settings');
					var intent = new Intent(Settings.ACTION_LOCATION_SOURCE_SETTINGS);
					var main = plus.android.runtimeMainActivity();
					main.startActivity(intent); // 打开系统设置GPS服务页面
				
				// ios平台
				if (uni.getSystemInfoSync().platform == 'ios') {
					var UIApplication = plus.ios.import("UIApplication");
					var application2 = UIApplication.sharedApplication();
					var NSURL2 = plus.ios.import("NSURL");
					var setting2 = NSURL2.URLWithString("App-Prefs:root=Privacy&path=LOCATION");
					application2.openURL(setting2);
					plus.ios.deleteObject(setting2);
					plus.ios.deleteObject(NSURL2);
					plus.ios.deleteObject(application2);
				}
			if (cancel) {
				// do sth...
			}
		}
	})
}
//判断定位权限开启
 function judgeLoc(){
	  let locStatus = false
	  let locSwitch = false
	 // #ifdef APP-PLUS
	 if (!permision.checkSystemEnableLocation()) {
	 	 // openLoc()
		 locSwitch=false
	 } else {
	 	locSwitch=true
	 }
	 // check_permission('android.permission.ACCESS_FINE_LOCATION',"location",'定位').then((data)=>{
		//  locStatus=true
	 // }).catch((err)=>{
		//  locStatus=false
	 // })
	 if (uni.getSystemInfoSync().osName == 'ios') {
		if (permision.judgeIosPermission("location")) {
			locStatus=true
		} else {
			locStatus=false
		}
	} else {
		let res = await permision.requestAndroidPermission('android.permission.ACCESS_FINE_LOCATION')
		if (res == 1) {
			locStatus=true
		} else {
			locStatus=false
		}
	}
	 // #endif
	 // #ifdef H5
	 locStatus = locSwitch = true
	 // #endif
	 return new Promise((resolve, reject) => {
	 	if (locStatus && locSwitch) {
	 		resolve()
	 	} else {
	 		reject({
	 			locStatus: locStatus,
	 			locSwitch: locSwitch
	 		})
	 	}
	 })
 }
 function judgeLoc2(){
 	// #ifdef APP-PLUS
	judgeLoc().catch((data) => {
		if (!data.locStatus) { //未授权
			check_permission('android.permission.ACCESS_FINE_LOCATION',"location",'定位')
		} else if (!data.locStatus && !data.locSwitch) { //未开启定位开关
			openLoc()
		}
	})
	// #endif
 }